/* Dijkstra's Algorithm (Adj List) 
   finding the length of the shortest path between src and dst nodes*/
#include <stdio.h>
#include <stdlib.h>

typedef struct adj_list
{
	int i,wt;
	struct adj_list *next;
} node;


void initialize(int n,int src,int s[],int d[],node* a[])
{
	int i;
	node *tmp;
	for(i=1;i <= n;i++)
	{
		d[i]=9999;
		s[i]=0;
	}
	s[src]=1;
	for(tmp=a[src];tmp!=NULL;tmp=tmp -> next)
		d[tmp -> i]=tmp -> wt;
}

void main()
{
	
	int n,u,i,k,j,src,d[10],s[10],dst,min;
	node *a[10]={NULL},*tmp,*temp;
	FILE* input=fopen("dijkstra.txt","r");
	fscanf(input,"%d",&n);
	printf("\n number of nodes :%3d\n",n);

    for(i=1;i <= n;i++)
	{
		while(1)
		{
			fscanf(input,"%d %d",&k,&j);
			if(k==0)
				break;
			temp=(node*)malloc(sizeof(node));
			temp -> i=k;
			temp -> wt=j;
			temp -> next=a[i];
			a[i]=temp;
		}
	}

	printf("\nThe graph is\n ");
	for(i=1;i <= n;i++)
	{
		printf("\n%3d----",i);
		tmp=a[i];
		while(tmp!=NULL)
		{
			printf("\t%4d %4d",tmp -> i,tmp -> wt);
			tmp=tmp -> next;
		}
	}
	printf("\nEnter the source & destination :");
	scanf("%d %d",&src,&dst);
       	initialize(n,src,s,d,a);


	u=src; 
	while(u!=dst)
	{

		u=9999; min=9999;
		for(i=1;i <= n;i++)
			if(s[i]==0)
						
				if(d[i] < min)
				{
					min=d[i]; 
					u=i;   
				}
			
	
		if(u==9999) exit(1);
		s[u]=1; 
		tmp=a[u];

		while(tmp!=NULL)
		{
			if(s[tmp -> i]==0)
				if (d[tmp -> i] > d[u]+tmp -> wt)
					{ d[tmp -> i]=d[u]+tmp -> wt;
				    }
		    tmp=tmp -> next;
		}
								
	}
	printf("\nThe minimum distance between %d and %d is %d\n",src,dst,d[dst]);

}

