/* Krushkal's Algorithm */

#include <stdio.h>
#include <stdlib.h>

typedef struct krus
{
	int u,v,wt;
	struct krus *next;
} edge;

edge *e;
int a[10][10],t[10][2],b[10][10],s[10],n,sum=0;

int find(int x)
{
	int i,j;
	for(i=1;i <= n;i++)
		for(j=1;j <= b[i][0];j++)
			if(b[i][j]==x) return i;
	return 0;
}

void unite(int x,int y)
{
	int i,j,k;
	i=(x < y)?x:y;
	k=(x < y)?y:x;
	for(j=1;j <= b[k][0];j++)
		b[i][(j+b[i][0])]=b[k][j];
	b[i][0] +=b[k][0];
}

void kruskal()
{
	int k=0,i,j;
	edge *node;
	node=e;
	while((node!=NULL)&&(k < n))
	{
		i=find(node->u);
		j=find(node->v);
		if(i!=j)
		{
			unite(i,j);
			sum+=node->wt;
			s[i]=s[j]=1;
			t[k][0]=node->u;
			t[k++][1]=node->v;
		}
		node=node->next;
	}
	if(k < (n-2))
	{
		printf("Graph is not connected");
		exit(1);
	}
}

edge *insert(int i,int j,int wt)
{
	edge *tmp,*cur,*prev,*p=e;
	tmp=(edge*)malloc(sizeof(edge));
	tmp->u=i;
	tmp->v=j;
	tmp->wt=wt;
	tmp->next=NULL;
	if(p==NULL)		return tmp;
	if(wt <= p->wt)
	{
		tmp->next=p;
		return tmp;
	}
	cur=p;
	prev=NULL;
	while((cur!=NULL)&&(wt > cur->wt))
	{
		prev=cur;
		cur=prev->next;
	}
	tmp->next=cur;
	prev->next=tmp;
	return p;
}


void main()
{
	int i,j;
	printf("Enter the number of nodes :");
	scanf("%d",&n);
	printf("ENTER INFINITY WEIGHT (i.e. 999 ) IF THE EDGE BETWEEN TWO NODES DOES NOT EXIST!!!");
	printf("Enter the adjacency matrix\n");
	for(i=1;i <= n;i++)
	{ printf("enter the weights of %d row of the matrix \n",i);
		for(j=1;j <= n;j++)
			scanf("%d",&a[i][j]);
	}
	for(i=1;i <= n;i++)
		for(j=i+1;j <= n;j++)
			e=insert(i,j,a[i][j]);
	for(i=1;i <= n;i++)
	{
		b[i][0]=1;
		b[i][1]=i;
	}
	kruskal();
	printf("Weight of minimum spanning tree = %d\nSpanning tree",sum);
	for(i=0;i < n-1;i++)
		printf("\n %d\t%d",t[i][0],t[i][1]);

}

